#ifndef __PLAYER_H
#define __PLAYER_H

struct Grid;

/** Liste des direction possible
 */
enum Direction
{
  TOP = 'z',
  LEFT = 'q',
  RIGHT = 'd',
  BOTTOM = 's'
};

/**
 * @struct coordonee player.h
 * @brief Cette structure contient une position colone ligne
 */
struct coordonee
{
    int col, row;
};

/**
 * @struct Player player.h
 * @brief Cette structure contient une position colone ligne du joueur
 */
struct Player
{
  int col, row;
};

/** renvoye la position du joueur en fonction d'un mouvement
 *
 * @param col position colonne du joueur 
 * @param row position ligne du joueur 
 * @param direction direction du joueur
 */
struct coordonee position_to(int col, int row, enum Direction direction);

/** En fonction d'un movement regarde si c'est posible et fait les changement des coordonner du joueur
 *
 * @param grid la struct grid pour recuperer la taille total du tableau
 * @param direction direction du joueur
 */
void move_player(struct Grid *grid, enum Direction direction);

/** En fonction d'un movement regarde si c'est posible et fait les changement des coordonner du joueur
 *
 * @param grid la struct grid 
 * @param position_col position de la box col
 * @param position_row position de la box row
 * @param direction direction du joueur
 */
int move_box(struct Grid *grid, int position_col, int position_row, enum Direction direction);

int win_condition(struct Grid *grid);

#endif