#include "cester.h"
#include "grid.h"
#include "player.h"
#include <stdio.h>

CESTER_TEST(test_grid_get_cell, grid, {
  struct Grid *grid = new_grid(5, 5);
  for (int x = 0; x < 5; ++x)
  {
    for (int y = 0; y < 5; ++y)
    {
      cester_assert_equal(NONE, get_grid(grid, x, y));
    }
  }
})

CESTER_TEST(test_grid_change_cell, grid, {
  struct Grid *grid = new_grid(5, 5);
  change_cell_grid(grid, 1, 2, GOAL);
  Affichage_grid(grid);
  cester_assert_equal(GOAL, get_grid(grid, 1, 2));
})

CESTER_TEST(test_move_direction, grid,
            {
              struct Grid *grid = init_level("./level1.txt");
              Affichage_grid(grid);
              move_player(grid, TOP);
              Affichage_grid(grid);
              cester_assert_equal(PLAYER, get_grid(grid, 11, 5));
            }

)
